#!/usr/bin/python

import sys
import os
import itertools
import commands
import calendar

def grouper(n, iterable, fillvalue=None):
    "grouper(3, 'ABCDEFG', 'x') --> ABC DEF Gxx"
    args = [iter(iterable)] * n
    return itertools.izip_longest(fillvalue=fillvalue, *args)


def print_month(month, year):
  c = commands.getoutput("cal -m %s %s" % (month, year))
  a = c.split('\n')
  limit = 5

  line = 0
  count = 0
  first = None

  secs = []

  for l in a[2:-1]:
    line += 1
    for n in grouper(3, l):
      count += 1
      d = ''.join(n[:2]).replace(' ', '')
      if d and not first:
        first = count
        if count < limit:
          secs += [ '', '', '' ]
        else:
          secs = secs[4:]
      secs.append(d)

  if len(secs) == 31:
    secs = [ '', '', '', '', '', '', '' ] + secs

  fh = open('tflipside.svg', 'r')
  temp = ''.join(fh.readlines())
  fh.close()

  temp = temp.replace('$mon', month)

  fh = open('%s-%s-0.svg' % (year, month), 'w')
  fh.write(temp)
  fh.close()

  fh = open('template.svg', 'r')
  temp = ''.join(fh.readlines())
  fh.close()

  temp = temp.replace('$year', year)
  temp = temp.replace('$month', calendar.month_name[int(month)])
  temp = temp.replace('$mon', month)

  fh = open('dates.lst', 'r')
  dates = fh.readlines()
  fh.close()

  things = {}
  for date in dates:
    (monthday, items) = date.split(':')
    (dmonth, dday) = monthday.split('-')
    if int(month) == int(dmonth):
      things[str(int(dday))] = items.split(',')
        

  x = 1
  for sec in secs:
    tbr = '$%s<' % str(x)
    temp = temp.replace(tbr, sec+"<")
    if sec == '':
      bn = 'id="box%s"' % str(x)
      temp = temp.replace(bn, bn+" style='opacity: 0'")
    if things.has_key(sec):
      y = 1
      for item in things[sec]:
        tbr = '$%sc%s<' % (str(x), str(y))
        temp = temp.replace(tbr, item+'<')
        y += 1
    for y in range(1, 4):
      tbr = '$%sc%s<' % (str(x), str(y))
      temp = temp.replace(tbr, '<')
    x += 1

  fh = open('%s-%s-1.svg' % (year, month), 'w')
  fh.write(temp)
  fh.close()

for m in range(1,13):
    m = str(m)
    if len(m) == 1:
      m = '0'+m
    print_month(m, sys.argv[1])
